/*		Name:		exp.c
		Version:	0.9.16
		Date:		28/11/2003
		Expressions 
*/

#include <stdlib.h>
#include "exp.h"


ExpSymbol exp_presidence[] ={
    {EXP_AND, ".", 60},
    {EXP_XOR, "^", 50},
    {EXP_OR,  "+", 40},
    {EXP_AND, "&", 60},
    {EXP_OR,  "|", 40},
    {EXP_EQ,  "=", 10},
    
    {-1, NULL, 0}  };

Exp* exp_exp(char* ptr, char** endptr, int presedence)
{
 char* i = ptr;
 char* prepeek;
 char* prepeek2;
 Exp* ret;
 Exp* second;
 ExpSymbol* current_sym;
 ExpSymbol* next_sym;
 ret = exp_val(i, &i);
 if (!i) {*endptr = NULL;return NULL;}
 while (1){
    prepeek = i;
    current_sym = exp_find_symbol (i,&i);
    if (!(current_sym->string))               {*endptr = i;      return ret;}
    if (current_sym->presedence <= presedence){*endptr = prepeek;return ret;}
    if (current_sym->type == EXP_EQ) {
        symbol_count--;
        ret->index=-1;
        }

    prepeek = i;
    second = exp_val(i, &i);
    if (!i) {*endptr = NULL;return NULL;}
    prepeek2 = i;
    next_sym = exp_find_symbol (i, &i);
    if (next_sym->presedence > current_sym->presedence){
        i = prepeek;
        second = exp_exp(i, &i, current_sym->presedence);
        if (!i) {*endptr = NULL;return NULL;}
        }
    else {
        i = prepeek2;
        }
    if (current_sym->type == EXP_EQ) {
        ret->type=second->type;
        ret->childA=second->childA;
        ret->childB=second->childB;
        ret->symbol=second->symbol;
        ret->invert=second->invert;
        ret->index=second->index;
        ret = exp_val(i, &i);
        if (!i) {*endptr = NULL;return NULL;}
        }
    else
        ret = exp_operate(ret, second, current_sym->type);
    }
 
 
 
}


Exp* exp_val(char* ptr,char** endptr)
{
 char* i;
 Exp* ret;
 while (isblank(*ptr)) ptr++;
 i = ptr;
 switch (*i) {
    case '(':
        i++; 
        ret = exp_exp(i, &i, 0);
        if (!i) {*endptr = NULL;return NULL;}
        while (isblank(*i)) i++;
        if (')' != *i) {
            *endptr = NULL;
            }
        else *endptr = i+1;
        break;
    case '!':
    case '~':
            i++;
            ret = exp_val(i, &i);
            if (!i) {*endptr = NULL;return NULL;}
            *endptr = i;
            ret->invert=1;
        break;
    default:
            ret = exp_get_symbol(ptr, &i);
            if (!i) {*endptr = NULL;return NULL;}
            *endptr = i;
        break;
    }
 return ret;
}

Exp* exp_get_symbol(char* start,char** end)
{
 char* i = start;
 char* string;
 Exp* ret;
 Exp* search = symbols;
 while (isblank(*start)) start++;
 i = start;
 while (isalnum(*i) ) i++;
 string = malloc((i-start) * sizeof(char));
 string = strncpy(string, start, i-start);
 
 ret = malloc(sizeof(Exp));
 ret->type = TERM;
 ret->invert = 0;
 ret->name = string;
 while (search){
    if (!strcmp(search->name, string)) break;
    search = search->next_symbol;
    }
 if (search) {
    ret->index=search->index;
    ret->type=search->type;
    ret->childA=search->childA;
    ret->childB=search->childB;
    ret->symbol=search->symbol;
    ret->index=search->index;
    }
 else {
    ret->index=symbol_count++;
    ret->next_symbol=symbols;
    symbols = ret;
    }
 *end = i;
 return ret;
}


ExpSymbol* exp_find_symbol (char* ptr, char** endptr)
{
 char* i = ptr;
 int index=0;
 int strindex;
 while (isblank(*i)) i++;

 while (exp_presidence[index].string){
    strindex=0;
    while (1){
        if (!exp_presidence[index].string[strindex]){
            *endptr = i+strindex;
            return &exp_presidence[index];
            }
        if (exp_presidence[index].string[strindex] != i[strindex]) break;
        strindex++;
        }
    index++;
    }
 return &exp_presidence[index];
}

Exp* exp_operate(Exp* childA, Exp* childB, ExpSymbolType symbol)
{
 Exp* ret = malloc(sizeof(Exp));
 ret->type = NONTERM;
 ret->invert = 0;
 ret->childA = childA;
 ret->childB = childB;
 ret->symbol = symbol;
 return ret;
}
